searchNodes=[{"doc":"FileStore allows you to read, write, upload, download, and interact with files, regardless of where they are stored.AdaptersThis package ships with the following adapters:FileStore.Adapters.DiskFileStore.Adapters.S3FileStore.Adapters.MemoryFileStore.Adapters.NullThe documentation for each adapter includes an example that demonstrates it's usage.","ref":"FileStore.html","title":"FileStore","type":"module"},{"doc":"Delete a file from the store.Examples iex&gt; FileStore.delete(store, &quot;foo&quot;) :ok","ref":"FileStore.html#delete/2","title":"FileStore.delete/2","type":"function"},{"doc":"Download a file from the store and save it to the given path.Examplesiex&gt; FileStore.download(store, &quot;foo&quot;, &quot;/path/to/bar.txt&quot;) :ok","ref":"FileStore.html#download/3","title":"FileStore.download/3","type":"function"},{"doc":"Get URL for your file, assuming that the file is publicly accessible.Examplesiex&gt; FileStore.get_public_url(store, &quot;foo&quot;) &quot;https://mybucket.s3-us-east-1.amazonaws.com/foo&quot;","ref":"FileStore.html#get_public_url/3","title":"FileStore.get_public_url/3","type":"function"},{"doc":"Generate a signed URL for your file. Any user with this URL should be able to access the file.Examplesiex&gt; FileStore.get_signed_url(store, &quot;foo&quot;) {:ok, &quot;https://s3.amazonaws.com/mybucket/foo?X-AMZ-Expires=3600&amp;...&quot;}","ref":"FileStore.html#get_signed_url/3","title":"FileStore.get_signed_url/3","type":"function"},{"doc":"List all of the files in the store.Examplesiex&gt; Enum.to_list(FileStore.list!(store)) [&quot;foo/bar&quot;]","ref":"FileStore.html#list!/1","title":"FileStore.list!/1","type":"function"},{"doc":"Configures a new store.Examplesiex&gt; FileStore.new(adapter: FileStore.Adapters.Memory) %FileStore{adapter: FileStore.Adapters.Memory, config: %{}}","ref":"FileStore.html#new/1","title":"FileStore.new/1","type":"function"},{"doc":"Read the contents of a file in store into memory.Examplesiex&gt; FileStore.read(store, &quot;foo&quot;) {:ok, &quot;hello world&quot;}","ref":"FileStore.html#read/2","title":"FileStore.read/2","type":"function"},{"doc":"Retrieve information about a file from the store.Examplesiex&gt; FileStore.stat(store, &quot;foo&quot;) {:ok, %FileStore.Stat{key: &quot;foo&quot;, etag: &quot;2e5pd429&quot;, size: 24}}","ref":"FileStore.html#stat/2","title":"FileStore.stat/2","type":"function"},{"doc":"Upload a file to the store. If a file with the given key already exists, it will be overwritten.Examplesiex&gt; FileStore.upload(store, &quot;/path/to/bar.txt&quot;, &quot;foo&quot;) :ok","ref":"FileStore.html#upload/3","title":"FileStore.upload/3","type":"function"},{"doc":"Write a file to the store. If a file with the given key already exists, it will be overwritten.Examplesiex&gt; FileStore.write(store, &quot;foo&quot;, &quot;hello world&quot;) :ok","ref":"FileStore.html#write/3","title":"FileStore.write/3","type":"function"},{"doc":"","ref":"FileStore.html#t:key/0","title":"FileStore.key/0","type":"type"},{"doc":"","ref":"FileStore.html#t:path/0","title":"FileStore.path/0","type":"type"},{"doc":"","ref":"FileStore.html#t:t/0","title":"FileStore.t/0","type":"type"},{"doc":"","ref":"FileStore.html#t:url/0","title":"FileStore.url/0","type":"type"},{"doc":"Stores files on the local disk. This is primarily intended for development.Configurationstorage_path - The path on disk where files are stored. This option is required.base_url - The base URL that should be used for generating URLs to your files.Exampleiex&gt; store = FileStore.new( ...&gt; adapter: FileStore.Adapters.Disk, ...&gt; storage_path: &quot;/path/to/store/files&quot;, ...&gt; base_url: &quot;http://example.com/files/&quot; ...&gt; ) %FileStore{...} iex&gt; FileStore.write(store, &quot;foo&quot;, &quot;hello world&quot;) :ok iex&gt; FileStore.read(store, &quot;foo&quot;) {:ok, &quot;hello world&quot;}","ref":"FileStore.Adapters.Disk.html","title":"FileStore.Adapters.Disk","type":"module"},{"doc":"Get an the path for a given key.","ref":"FileStore.Adapters.Disk.html#join/2","title":"FileStore.Adapters.Disk.join/2","type":"function"},{"doc":"Stores files in memory. This adapter is particularly useful in tests.Configurationname - The name used to register the process.base_url - The base URL that should be used for generating URLs to your files.Exampleiex&gt; store = FileStore.new( ...&gt; adapter: FileStore.Adapters.Memory, ...&gt; base_url: &quot;http://example.com/files/&quot; ...&gt; ) %FileStore{...} iex&gt; FileStore.write(store, &quot;foo&quot;, &quot;hello world&quot;) :ok iex&gt; FileStore.read(store, &quot;foo&quot;) {:ok, &quot;hello world&quot;}Usage in testsdefmodule MyTest do use ExUnit.Case setup do start_supervised!(FileStore.Adapters.Memory) :ok end test &quot;writes a file&quot; do store = FileStore.new(adapter: FileStore.Adapters.Memory) assert :ok = FileStore.write(store, &quot;foo&quot;, &quot;bar&quot;) assert {:ok, &quot;bar&quot;} = FileStore.read(store, &quot;foo&quot;) end end","ref":"FileStore.Adapters.Memory.html","title":"FileStore.Adapters.Memory","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"FileStore.Adapters.Memory.html#child_spec/1","title":"FileStore.Adapters.Memory.child_spec/1","type":"function"},{"doc":"Starts an agent for the test adapter.","ref":"FileStore.Adapters.Memory.html#start_link/1","title":"FileStore.Adapters.Memory.start_link/1","type":"function"},{"doc":"Stops the agent for the test adapter.","ref":"FileStore.Adapters.Memory.html#stop/3","title":"FileStore.Adapters.Memory.stop/3","type":"function"},{"doc":"Does not attempt to store files.Exampleiex&gt; store = FileStore.new(adapter: FileStore.Adapters.Null) %FileStore{...} iex&gt; FileStore.write(store, &quot;foo&quot;, &quot;hello world&quot;) :ok iex&gt; FileStore.read(store, &quot;foo&quot;) {:ok, &quot;hello world&quot;}","ref":"FileStore.Adapters.Null.html","title":"FileStore.Adapters.Null","type":"module"},{"doc":"Stores files using Amazon S3.DependenciesTo use this adapter, you'll need to install the following dependencies:def deps do [ {:ex_aws_s3, &quot;~&gt; 2.0&quot;}, {:hackney, &quot;&gt;= 0.0.0&quot;}, {:sweet_xml, &quot;&gt;= 0.0.0&quot;} ] endConfigurationbucket - The name of your S3 bucket. This option is required.base_url - The base URL that should be used for generating the public URLs to your files.ex_aws - A keyword list of options that can be used to configure ExAws.prefix - An optional prefix for the FileStore that acts like a parent directory. If the prefix is &quot;images&quot;, then storing a file (&quot;cat.jpg&quot;) in S3 with this store will have the resolved key or &quot;images/cat.jpg&quot;. (This is most useful with use FileStore.Config modules.)Exampleiex&gt; store = FileStore.new( ...&gt; adapter: FileStore.Adapters.S3, ...&gt; bucket: &quot;mybucket&quot; ...&gt; ) %FileStore{...} iex&gt; FileStore.write(store, &quot;foo&quot;, &quot;hello world&quot;) :ok iex&gt; FileStore.read(store, &quot;foo&quot;) {:ok, &quot;hello world&quot;}","ref":"FileStore.Adapters.S3.html","title":"FileStore.Adapters.S3","type":"module"},{"doc":"Define a configurable store.UsageFirst, define a new module:defmodule MyApp.Storage do use FileStore.Config, otp_app: :my_app endIn your config files, you'll need to configure your adapter:config :my_app, MyApp.Storage, adapter: FileStore.Adapters.NullIf you need to dynamically configure your store at runtime, you can implement the init/1 callback.def init(opts) do Keyword.put(opts, :foo, &quot;bar&quot;) endExampleiex&gt; MyApp.Storage.write(&quot;foo&quot;, &quot;hello world&quot;) :ok iex&gt; MyApp.Storage.read(&quot;foo&quot;) {:ok, &quot;hello world&quot;}","ref":"FileStore.Config.html","title":"FileStore.Config","type":"module"},{"doc":"A struct that holds file information.Fieldskey - The unique identifier for the file.etag - A fingerprint for the contents of a file. This is almost always an MD5 checksum.size - The byte size of the file.","ref":"FileStore.Stat.html","title":"FileStore.Stat","type":"module"},{"doc":"Compute an MD5 checksum.Exampleiex&gt; FileStore.Stat.checksum(&quot;hello world&quot;) &quot;5eb63bbbe01eeed093cb22bb8f5acdc3&quot;","ref":"FileStore.Stat.html#checksum/1","title":"FileStore.Stat.checksum/1","type":"function"},{"doc":"Compute the MD5 checksum of a file on disk.Exampleiex&gt; FileStore.Stat.checksum_file(&quot;test/fixtures/test.txt&quot;) {:ok, &quot;0d599f0ec05c3bda8c3b8a68c32a1b47&quot;} iex&gt; FileStore.Stat.checksum_file(&quot;test/fixtures/missing.txt&quot;) {:error, :enoent}","ref":"FileStore.Stat.html#checksum_file/1","title":"FileStore.Stat.checksum_file/1","type":"function"},{"doc":"","ref":"FileStore.Stat.html#t:t/0","title":"FileStore.Stat.t/0","type":"type"}]